package net.pricefx.formulaengine;

import org.apache.commons.lang3.exception.ExceptionUtils;

public class StackTraceUtil {

    protected StackTraceUtil() {}

    public static int getScriptLineNumber(final Throwable t) {
        String[] frames = ExceptionUtils.getStackFrames(t);
        for(String e : frames) {
            if(true) {
                int colonPos = e.indexOf(":");
                if(colonPos == -1)
                    continue;
                int endPos = e.indexOf(")", colonPos);
                if(endPos == -1)
                    continue;

                String lineNumber = e.substring(colonPos+1,endPos);
                try {
                    return Integer.valueOf(lineNumber);
                } catch (NumberFormatException ex) {
                    return 0;
                }
            }
        }
        return 0;
    }
}
